"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var use_is_in_viewport_1 = __importDefault(require("use-is-in-viewport"));
function WaypointLazy(props) {
    var _a = Object.assign({ width: 400, height: 300, fallback: null, threshold: 0.1 }, props), width = _a.width, height = _a.height, fallback = _a.fallback, threshold = _a.threshold;
    var _b = react_1.useState({ last: null, seen: false, play: false }), state = _b[0], setState = _b[1];
    var _c = use_is_in_viewport_1.default({ threshold: threshold }), isInViewport = _c[0], childRef = _c[1];
    react_1.useEffect(function () {
        if (props.onVisibleChange) { // && isInViewport !== state.last) { // hook only triggers on isInViewport
            // Make sure we don't fire 'no visibility' when the element has not been seen yet
            var isNotVisibleAndNotSeenYet = !isInViewport && !state.seen;
            if (!isNotVisibleAndNotSeenYet) {
                props.onVisibleChange(isInViewport ? true : false);
                // setState((p: any) => ({ ...p, last: isInViewport }));
            }
        }
        if (isInViewport && !state.seen) {
            setState(function (p) { return (__assign({}, p, { play: true, seen: true })); });
        }
        else if (!isInViewport && state.seen) {
            setState(function (p) { return (__assign({}, p, { play: false })); });
        }
    }, [isInViewport]);
    // const Lazy = React.useMemo( () => React.lazy(f), [f] );
    return (react_1.default.createElement(react_1.default.Suspense, { fallback: fallback },
        react_1.default.createElement("div", { ref: childRef }, state.seen ? react_1.default.createElement(react_1.default.Fragment, null, props.children) : react_1.default.createElement("div", { style: { width: width, height: height } }))));
}
exports.default = WaypointLazy;
/*
export default function WaypointLazySuspend(props: Props) {
  const {width, height, fallback} = Object.assign({width:400, height:300, fallback:null}, props);
  return (<React.Suspense fallback={ null }> <WaypointLazy { ...props } /> </React.Suspense>);
}
*/
//# sourceMappingURL=index.js.map